use std::path::PathBuf;

use player::HOSTED_DEVICE;
use viperid::VResult;

use crate::go_builder::GoBuilder;

mod go_builder;

fn main() -> VResult<()> {
    let builder = GoBuilder::new(
        &PathBuf::from("example_project"))?;
    let wasm = builder.build()?;

    let mut executor = player::Executor::new(&wasm)?;

    minifb_host::host(HOSTED_DEVICE.with(|d| d.share()), || {
        executor.update();
        executor.get_error()?;
        Ok(())
    })?;

    Ok(())
}
